Bug 1299841 - [tiering]: Files of size greater than that of high watermark level should not be promoted
Summary: [tiering]: Files of size greater than that of high watermark level should not...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Gluster Storage
Classification: Red Hat
Component: tier
Version: rhgs-3.1
Hardware: Unspecified
OS: Unspecified
unspecified
medium
Target Milestone: ---
: RHGS 3.2.0
Assignee: Milind Changire
QA Contact: krishnaram Karthick
URL:
Whiteboard: tier-migration
Depends On: 1362198
Blocks: 1351522
TreeView+ depends on / blocked
 
Reported: 2016-01-19 11:38 UTC by krishnaram Karthick
Modified: 2017-03-23 05:26 UTC (History)
5 users (show)

Fixed In Version: glusterfs-3.8.4-1
Doc Type: No Doc Update
Doc Text:
undefined
Clone Of:
: 1349284 (view as bug list)
Environment:
Last Closed: 2017-03-23 05:26:41 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2017:0486 normal SHIPPED_LIVE Moderate: Red Hat Gluster Storage 3.2.0 security, bug fix, and enhancement update 2017-03-23 09:18:45 UTC

Description krishnaram Karthick 2016-01-19 11:38:13 UTC
Description of problem:
Today, When a file is heated which is of size greater than the size of hot tier's high water mark, the file is promoted. Gluster should intelligently determine that the size of the file is more than high watermark and should not get promoted. 

with the following scenario,

hot tier capacity: 100Gb
high water mark - 70% i.e., 70Gb
File is created of size 80Gb

Having such file in hot tier has multiple consequences.

1) When this file is in hot tier, we always exceed high watermark and get into complete demotion mode. As a result, we make all other on hot tier a possible candidate for demotion.
2) No other files will be promoted until this file moves to cold tier
3) Possibility of moving such a huge file back and forth from cold to hot tier which might affect performance

Version-Release number of selected component (if applicable):
glusterfs-3.7.5-15.el7rhgs.x86_64

How reproducible:
Always

Steps to Reproduce:
1. create a gluster volume
2. create a 80Gb file, say file1
3. Attach hot tier of size 100Gb and set high watermark at 70%
4. heat the file - file1 created in step 2

Actual results:
File gets promoted

Expected results:
File should not get promoted

Additional info:

Comment 4 Atin Mukherjee 2016-08-18 05:51:06 UTC
http://review.gluster.org/#/c/15065/ is already in 3.8 branch now, moving the state to POST

Comment 5 Atin Mukherjee 2016-09-17 15:04:25 UTC
Upstream mainline : http://review.gluster.org/14780
Upstream 3.8 : http://review.gluster.org/15065

And the fix is available in rhgs-3.2.0 as part of rebase to GlusterFS 3.8.4.

Comment 8 krishnaram Karthick 2016-10-12 03:06:49 UTC
Verified the bug in glusterfs-server-3.8.4-2

steps followed to verify the bug,

1) created a dist-disperse volume and created a file of size 10GB (say, file-1)
2) attached hot tier (capacity 40GB) and set high watermark to 20% i.e., 8GB
3) allowed for background fixlayout to complete on hot tier
4) kept sending writes to file-1

File did not promote to hot tier after default promotion cycle of 2 minutes. File skipped for promotion was logged properly.


[2016-10-12 03:00:01.980554] I [MSGID: 109038] [tier.c:535:tier_can_promote_file] 0-tier-vol-tier-dht: Estimated block count consumption on hot tier (2322101) exceeds hi watermark (20%). File will not be promoted.

Marking the bug as verified.

Comment 10 errata-xmlrpc 2017-03-23 05:26:41 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://rhn.redhat.com/errata/RHSA-2017-0486.html


Note You need to log in before you can comment on or make changes to this bug.